//------------------------------------------------------------------------------
//
// Ansteuerung der FHS 20 Sendeeinheit mit RS232
// Hauptprogramm:   FHS 20.cc
// Autor:           Josef Reininger
// Datum:           siehe SW Versionen
// Version:         siehe SW Versionen
// Copyright:       Josef Reininger
//
//------------------------------------------------------------------------------
/*
Programmfunktion:
FHS 20 Sendeeinheit wird ber RS232 Nr.:1 mit 9600 Baud bedient.
Die Programmierung und Debuggen ist ber RS232 Nr.: 0 mglich.
*/

void FS20US(byte FS20ADR, byte FS20Befehl1, byte FS20Befehl2)
{
  byte c_FS20;
  FS20_STATUS=0;
  Serial_Write(FS20US_RS232,0x02);            // Startzeichen FS20 Funk
  Serial_Write(FS20US_RS232,0x06);            // Befehlslnge
  Serial_Write(FS20US_RS232,0xF1);            // Befehls ID => Befehl einmal senden
  Serial_Write(FS20US_RS232,Hausadresse1);
  Serial_Write(FS20US_RS232,Hausadresse2);
  Serial_Write(FS20US_RS232,FS20ADR);         // FS 20 Adresse
  Serial_Write(FS20US_RS232,FS20Befehl1);     // Rollladen einfahren
  Serial_Write(FS20US_RS232,FS20Befehl2);     // Timerzeit
//Msg_WriteText(" FS20 ");
//AbsDelay(100);             !!!!ACHTUNG eventuell AUFHNGEN mglich, wenn keine Daten kommen
  while (FS20count==0) FS20count=Serial_IRQ_Info(FS20US_RS232,RS232_FIFO_RECV);   // Abfrage wieviel Zeichen empfangen wurden
  if (FS20count)
  {
      c_FS20=1;
      while(FS20count)
      {
          FS20sz=Serial_ReadExt(FS20US_RS232);        // Puffer auslesen
//Msg_WriteText(" FS20 Antwort: ");Msg_WriteWord(FS20sz);  Msg_WriteChar(CR);
          if (c_FS20==3 && FS20sz)
          {
            FS20_STATUS=FS20sz;
            if (FS20_STATUS) FS20Error=FS20_STATUS;
            m_Error=1;                          // Error anzeigen
          }
          c_FS20++;
          if(FS20sz==0x100) break;                    // bei 0x100 ist der Puffer leer
          FS20count=Serial_IRQ_Info(FS20US_RS232,RS232_FIFO_RECV);
      }
  }
}
void FS20WS (void)
{
//Msg_WriteText("STIEGE ");Msg_WriteWord(RS232);
  if (RS232==FS20WS_DatenRS)
  {
    FS20US(WS1_Stiege_FS20ADR,0x12,0);
    RS232=WR_RS;
  // Msg_WriteText("STIEGE IF ");Msg_WriteWord(RS232);
  }
  else RS232=FS20WS_RS;
}
void FS20ST4 (void)
{
  if (RS232==FS20ST4_DatenRS)
  {
//    FS20US(ST4_Adr,0x39,0x6F);   //ST4_Ventilator_FS20ADR     FS20ST4_DatenRS
    FS20US(FS20ST4_Adr,FS20Befehl,FS20Erweitrg);           //0x39,0x6F
    RS232=WR_RS;
  }
  else RS232=FS20ST4_RS;
}
